<?php
global $CFG;

function recursivecopy($sourcepath,$destpath){
	if ($dir = @opendir($sourcepath)){
		$sourcepath = str_replace('//','/',$sourcepath);
		$destpath = str_replace('//','/',$destpath);
    	while (($file = readdir($dir)) !== false) 
    	{
      		if($file != ".." && $file != "." && $file!='install.php' && $file !='lang')
       		{
         		//test if the file has an extension
         		$pattern = '#\...?#';
         		if(preg_match($pattern,$file)){
         			if(!copy($sourcepath.'/'.$file,$destpath.'/'.$file)){
         				echo 'probleme : '.$sourcepath.'/'.$file.' vers '.$destpath.'/'.$file;
         				return false;
         			}
         		}
         		else{//it's a directory
         			//if dest directory does not exist : have to create it!
         			if(!is_dir($destpath.'/'.$file)){
         				if(!mkdir($destpath.'/'.$file)){
         					return false;
         				}
         			}
         			if(!recursivecopy($sourcepath.'/'.$file,$destpath.'/'.$file)){
         				return false;
         			}
         		}
       		}
    	} 
		closedir($dir);
		return true;
 	}
 	else{
 		return false;
 	}
}

//test installation files.
$selffilename = $_SERVER['SCRIPT_FILENAME'];
//windows conveniance => replace '\' by '/'
if (getenv("OS")=="Windows_NT"){
    $selffilename = str_replace('\\','/',$selffilename);
}

$selflocation = substr($selffilename,0,strrpos($selffilename,'/')+1);

$allexist = !file_exists($selflocation.'blocks/referencement/block_referencement.php') ? 'block_referencement.php' : 
( !file_exists($selflocation.'blocks/referencement/settings.php')? 'settings.php' : 
( !file_exists($selflocation.'lib/repository/cmis_repository_wrapper.php') ?'cmis_repository_wrapper.php' : 
( !file_exists($selflocation.'lib/repository/cmis.php') ? 'cmis.php' :
( !file_exists($selflocation.'lib/repository/depositandreferencement.php') ? 'depositandreferencement.php' :
( !file_exists($selflocation.'lib/repository/lib.php') ? 'lib.php' : 
( !file_exists($selflocation.'lib/repository/rapatriement.php') ? 'rapatriement' : 
( !file_exists($selflocation.'lib/repository/referencement.php') ? 'referencement.php' :
( !file_exists($selflocation.'lib/repository/searchcallback.php') ? 'searchcallback.php' :
( !file_exists($selflocation.'mod/resource/type/file/localfile.php') ? 'localfile.php' :
( !file_exists($selflocation.'mod/resource/type/file/localpath.php') ? 'localpath.php' :
( !file_exists($selflocation.'mod/resource/type/file/resource.class.php') ? 'resource.class.php' :
( !file_exists($selflocation.'pix/i/sheetlist.gif') ? 'sheetlist.gif' : 
( !file_exists($selflocation.'lang/fr_utf8/block_referencement.php') ? 'lang_block_ref' : 
( !file_exists($selflocation.'lang/fr_utf8/referencement.php') ? 'lang_ref' :
( !file_exists($selflocation.'lang/fr_utf8/help/referencement.html') ? 'help_referencement' :
( !file_exists($selflocation.'lang/fr_utf8/help/orifilesearch.html') ? 'help_orisearch' :
( !file_exists($selflocation.'files/index.php') ? 'files/index.php' : true)))))))))))))))));


if($allexist != 1){
	echo'<p style="color:red; font-size:21">SOME INSTALLATION FILES ARE MISSING<br>INSTALLATION ABORDED.</p><br>'.$allexist;die;
}

//test inputs variables.
!empty($_POST['ROOT_LOCATION']) ? $rootloc = $_POST['ROOT_LOCATION'] : $rootloc=false;
$rootloc==false ? $rootmessage='Champs requis' : $rootmessage='' ;

if($rootloc && !is_dir($rootloc)){
	$rootmessage = 'Le dossier sp&eacute;cifi&eacute; n\'existe pas (ou est un fichier).';
}

if($rootmessage==''){
	if(file_exists($rootloc.'/config.php')){
		require_once($rootloc.'/config.php');
	}
	
	if(!is_object($CFG)){
		$rootmessage = 'Le dossier sp&eacute;cifi&eacute; ne semble pas &ecirc;tre une racine moodle.';
	}
	else{
		$dataloc = $CFG->dataroot;
		//rename "file" directory in ".old_file", except if .old_file already exists
		if( !file_exists($rootloc.'/mod/resource/type/.old_file')){
			if(! rename($rootloc.'/mod/resource/type/file',$rootloc.'/mod/resource/type/.old_file')){
				echo'<p style="color:red; font-size:21">ERROR WHILE SAVING OLD RESOURCE TYPE,<br>INSTALLATION ABORDED.</p>';die;
			}
		}
		
		//copy everything but languages files
		if(!recursivecopy($selflocation,$rootloc)){
			echo'<p style="color:red; font-size:21">ERROR WHILE COPYING FILES,<br>INSTALLATION ABORDED.</p>';die;
		}
		
		//copy languages files 
		if(!copy($selflocation.'/lang/fr_utf8/referencement.php',$CFG->dataroot.'/lang/fr_utf8/referencement.php') || 
		!copy($selflocation.'/lang/fr_utf8/block_referencement.php',$CFG->dataroot.'/lang/fr_utf8/block_referencement.php')||
		!copy($selflocation.'/lang/fr_utf8/help/referencement.html',$CFG->dataroot.'/lang/fr_utf8/help/referencement.html')||
		!copy($selflocation.'/lang/fr_utf8/help/orifilesearch.html',$CFG->dataroot.'/lang/fr_utf8/help/orifilesearch.html')){
			echo '<p style="color:red; font-size:21">ERROR WHILE COPYING LANGUAGES FILES,<br>INSTALLATION ABORDED.</p>';die;
		}
		
		//delete "orifile" if exists (update from older versions of the plugin)
		if( file_exists($rootloc.'/mod/resource/type/orifile')){
			if(!unlink($rootloc.'/mod/resource/type/orifile')){
				echo '<p style="color:red; font-size:21">Unable to delete "orifile" directory, please delete it manually :
				<br>'.$rootloc.'/mod/resource/type/orifile</p><br>';
			}
		}
		
		//add strings at the end of resource language file.
		$string = null;
		require_once($CFG->dataroot.'/lang/fr_utf8/resource.php');
		$string['referencement'] = 'R&eacute;f&eacute;rencement ORI-OAI';
		$string['doreference'] = 'R&eacute;f&eacute;rencer le fichier dans ORI-OAI';
		$string['orifilesearch'] = 'Rechercher une ressource avec ORI-OAI-Search';
		$file = fopen($CFG->dataroot.'/lang/fr_utf8/resource.php','w');
		fwrite($file,"<?php\n");
		foreach($string as $k=>$v){
			$v=str_replace('\'','\\\'',$v);
			fwrite($file,'$string[\''.$k.'\'] = \''.$v.'\';'."\n");
		}
		fwrite($file,"?>");
		fclose($file);
		echo '<p style="color:red; font-size:21">INSTALLATION COMPLETE.</p>';die;
	}
}

?>

<html>
<head>
<title>Installation - Block Referencement</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body bgcolor="#FFFFFF" text="#000000">
<form method="post" action="<?php echo $_SERVER['PHP_SELF'];?>" name="form">
  <table border="0" cellspacing="3" cellpadding="2" align="center">
	<tr>
      <td  colspan="2" align="center"><b><font size="4">Parametrage</font></b>
      </td>
    </tr>
    <tr>
      <td  colspan="2" align="center">
        <table border="0" cellspacing="3" cellpadding="2" align="center">
          <tr>
            <td>Emplacement de Moodle (racine)</td>
            <td>
              <input size="40" type="text" name="ROOT_LOCATION"  
              	<?php
              	echo 'value="'.$rootloc.'"';
              	if($rootmessage != ''){
              		echo 'style="border:solid; border-color:red"/></td><td>'.$rootmessage;
              	}else{echo '/>';}?>
            </td>
          </tr>
          <tr>
          	<td colspan="2" align="center"><input type="submit" name="SUBMIT" value="Valider"/></td>
          </tr>
        </table>
      </td>
    </tr>
</table>
</form>
</body>
</html>