<?php

global $CFG;
require_once($CFG->libdir.'/repository/cmis.php');
require_once($CFG->libdir.'/soaplib.php');
require_once($CFG->dirroot.'/auth/cas/CAS/CAS.php');

//return the url to directly access the ressource
function upload($resourcereference)
{
	global $USER;
	global $CFG;

	//test if a filename has been set 'manually' (return from existingfile)
	if(isset($_POST['fileext'])){
		$filename = $_POST['newname'].$_POST['fileext'];
	}
	else{
		//get the file name, without any directory
		$slashpos = strrpos($resourcereference,'/');
		if($slashpos == false)
		{
			$slashpos = strrpos($resourcereference,'\\');
		}
		else
		{
			$filename = substr($resourcereference,$slashpos+1);
		}
	}

	//For windows conveniance : replace / by \
	if (getenv("OS")=="Windows_NT"){
		$resourcereference = str_replace('/','\\',$resourcereference);
	}

	$override=false;
	$newversion = false;

	if(isset($_POST['groupaction']))
	{
		switch($_POST['groupaction'])
		{
			case 'replace':
				$override=true;
				break;
			case 'createNew':
				$filename = $_POST['newname'].$_POST['fileext'];
				break;
			case 'newVersion':
				$newversion = true;
				break;
			case 'nothing':
				return;
		}
	}


	$host = $CFG->block_referencement_host;
	$port = $CFG->block_referencement_port;
	$siteuri = $CFG->block_referencement_site;
	$accesspoint = $CFG->block_referencement_accesspoint;
	$remotepath = $CFG->block_referencement_relativeremotepath;
	$universallink = $CFG->block_referencement_universalurl;

	$login = $USER->username;
	$password = '';

	if(!empty($USER->id))
	{
		// %u = firstname-lastname
		$remotepath = str_replace('%u', strtolower($USER->firstname.'-'.$USER->lastname),$remotepath);
		// %l = login
		$remotepath = str_replace('%l', strtolower($login),$remotepath);

		$client =& new CMISRepositoryClient($login,$password,$host,$port,$siteuri,$accesspoint);
		if(!$client->authenticated){
			error(get_string('cmisclienterror','referencement'));
		}
		$fileid = $client->uploadfile($remotepath,$resourcereference,$filename,$override,$newversion);
		return 'http://'.str_replace('//','/',$host.':'.$port.'/'.$siteuri.'/'.$universallink.'/'.$fileid);
	}
	else
	{
		error(get_string('unlogged','referencement'));
	}
}


//
function doreferencement($urltoreference)
{
	if(isset($_POST['workflowtype']))
	{
		return;
	}
	global $CFG;
	global $USER;
	$wsdl = $CFG->block_referencement_workflow_url . $CFG->block_referencement_workflow_soapwsdl;
	if( substr($CFG->block_referencement_workflow_url,0,7) == 'http://'){
		$host = substr($CFG->block_referencement_workflow_url,7);
	}else if(substr($CFG->block_referencement_workflow_url,0,8) == 'https://' ){
		$host = substr($CFG->block_referencement_workflow_url,8);
	}
	$host = substr($host,0,strpos($host,'/'));
	if(strstr($host,':')){
		$port = substr($host,strpos($host,':')+1);
		$host = substr($host,0,strpos($host,':'));
	}else{
		$port = 80;
	}
	$testconnection = @fsockopen($host, $port, &$errno, &$errstr, 30);
	if(!$testconnection)
	{
		error(get_string('oriserverout','referencement'));
	}
	try{
		$client = new SoapClient($wsdl);
		$user = $USER->username;
		//get avaible metadata types for current user
		$params = array('in0'=>$user);
		$result = $client->getMetadataTypes1($params);
	}
	catch(Exception $e){
		error('ORI-OAI ERROR : '.$e->faultstring);
	}

	$myarray = $result->out->entry;
	$reftypes = array();
	foreach($myarray as $k=>$v)
	{
		if(substr($v->key,0,3) == 'tef'){continue;}
		$reftypes[$v->key] = $v->value;
	}
	$reftypes['nothing'] = get_string('donothing','referencement');


	$mform = new MoodleQuickForm('wftype','POST','');
	$mform->addElement('header', 'wftypehead', get_string('referencetype', 'referencement'));
	foreach($reftypes as $k=>$v)
	{
		$mform->addElement('radio','workflowtype','',$v,$k);
	}
	foreach($_POST as $k=>$v)
	{
		if($k == 'newname' || $k == 'groupaction') continue;
		if(is_array($v))
		{
			foreach($v as $key=>$val){
				$mform->addElement('hidden',$k.'['.$key.']',$val);
			}
		}else{
			$mform->addElement('hidden',$k,$v);
		}
	}
	$button = $mform->addElement('submit', 'validate',get_string('validate','referencement'));
	$buttonattributes = array('onclick'=>'var url = \'/lib/repository/referencement.php?referenceurl='.urlencode($urltoreference)
	.'&referencename='.urlencode($_POST['name']).'&\';
		var reftype = document.getElementsByName(\'workflowtype\');
		for(i=0;i<reftype.length;i++)
		{
			if(reftype[i].checked == true)
			{
				url += \'referencetype=\'+reftype[i].value;
				break;
			}
		}
		if(reftype[i].value != \'nothing\'){
			openpopup(url,\'Referencement\',null,true);
		}');
	$button->updateAttributes($buttonattributes);
	print_header();
	$mform->display();
	print_footer();die;
}
