<?php

require_once('../../config.php');
require_once('../moodlelib.php');
require_once('../soap/phpsoap.php');

//function to replace a data in a lom
function dom_replace(&$domdocument, $container,$prefix, $element, $data){
	$conts = $domdocument->getElementsByTagName($container);
	foreach($conts as $c)
	{
		$elts = $c->getElementsByTagName($element);
		foreach($elts as $e)
		{
			$c->removeChild($e);
		}
		$newelt = $domdocument->createElement($prefix.':'.$element);
		$newtxtelt = $domdocument->createTextNode($data);
		$newelt->appendChild($newtxtelt);
		$c->appendChild($newelt);
	}
}


//get required parameters
$referenceurl = required_param('referenceurl');
$referencetype = required_param('referencetype');
$referencename = optional_param('referencename');

$wsdl = $CFG->block_referencement_workflow_url . $CFG->block_referencement_workflow_soapwsdl;

$user = $USER->username;

//create the client
try{
	$client = new SoapClient($wsdl);
}
catch(Exception $e)
{
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

//create new empty workflow instance
$params = array(
'in0'=>null,
'in1'=>$referencetype,
'in2'=>$user );

try{
	$result = $client->newWorkflowInstance($params);
}catch(Exception $e){
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

$id = $result->out;

//get idp of created instance
$params = array(
'in0'=>$id,
'in1'=>$user);
try{
	$result = $client->getIdp($params);
}catch(Exception $e){
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

//get xml content of created instance
$idp = $result->out;

$params = array('in0'=>$idp);
try{
	$result = $client->getXMLForms($params);
}catch(Exception $e){
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

//modify xml content to introduce rigth url location and date
$dom = new DOMDocument();
$dom->loadXML($result->out);

//lom sheet
if( strstr($referencetype,'ressource_pedago') )
{
	dom_replace($dom,'technical','lom','location',$referenceurl);

	dom_replace($dom,'date','lom', 'dateTime',date('Y-m-d'));

	dom_replace($dom,'title','lom','string',$referencename);
}
//dublincore sheet
elseif( substr($referencetype,0,2) == 'dc' )
{
	dom_replace($dom,'dc','dc','identifier',$referenceurl);

	dom_replace($dom,'dc','dc', 'date',date('Y-m-d'));

	dom_replace($dom,'dc','dc','title',$referencename);
}

$xml = $dom->saveXML();
//save xml contents
$params = array(
'in0'=>$idp,
'in1'=>$xml);
try{
	$client->saveXML($params);
}catch(Exception $e){
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

//get url of the created workflow instance in md-editor
$params = array('in0'=>$idp);
try{
	$result = $client->getMdEditorUrl($params);
}catch(Exception $e){
	error($e->faultstring,$CFG->block_referencement_workflow_url);
}

if(is_array($result->out->entry)){
	$url = $result->out->entry[0]->value .'/'. $idp;
}
else{
	$url = $result->out->entry->value .'/'. $idp;
}
/*echo $url.'<br>';
 echo $xml;die;*/
header('Location: '.$url);

?>